package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.resources.IFile;

import polyglot.util.Position;

/**
 * Implementors should return non-null RevealData so that an editor can be opened
 * on the IFile and the Position can be selected and revealed.
 * 
 * @author Dehua Zhang
 * 
 */

public interface IActPosition {

	public static final class RevealData {
		private final IFile file;
		private final Position position;
		
		public RevealData(final IFile file, final Position position) {
			this.file = file;
			this.position = position;
		}
		
		public IFile getFile() {
			return file;
		}

		public Position getPosition() {
			return position;
		}
	}
	
	public RevealData getRevealData();
}
