package ca.mcgill.sable.abc.impact.visualizer.model;

import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.swt.graphics.Image;

/**
 * This just defines the type, client should extend AbstractTreeNode.
 * If getName() return null and the ITreeNode is ConvertibleIntoJavaElement, 
 *   ImpactViewLabelProvider will try to use the JavaUI to provide the text
 * If getImage() return null and the ITreeNode is ConvertibleIntoJavaElement,
 *   ImpactViewLabelProvider will try to use the JavaUI to provide the image
 * 
 * @author Dehua Zhang
 *
 */
public interface ITreeNode extends IAdaptable {
	
    public String getName();
    public Image getImage();
    public ITreeNode getParent();
    public List<ITreeNode> getChildren();
    public boolean hasChildren();
}
