package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IJavaElement;

import soot.SootClass;
import abc.impact.impact.ShadowingImpact;
import ca.mcgill.sable.abc.impact.visualizer.actions.RunImpactAnalysisActionDelegate;
import ca.mcgill.sable.abc.impact.visualizer.util.ImpactPluginUtil;

public final class ShadowingImpactAffectedTypeTreeNode extends AbstractTreeNode
		implements IActJavaElement {

	final private ShadowingImpact shadowingImpact;
	final private SootClass affectedType;
	private final IJavaElement jEle;
	
	public ShadowingImpactAffectedTypeTreeNode(ITreeNode parent, final ShadowingImpact shadowingImpact, final SootClass affectedType) {
		super(parent);
		this.shadowingImpact = shadowingImpact;
		this.affectedType = affectedType;
		this.name = "[" + affectedType + "]." + shadowingImpact.getFieldName();
		this.image = ImageFactory.SHADOWING_FIELD.getImage();
		this.jEle = ImpactPluginUtil.findJavaType(
				RunImpactAnalysisActionDelegate.getCurrentProject(),
				affectedType.getName());
	}

	public IJavaElement getJavaElement() {
		return jEle;
	}

	public SootClass getAffectedType() {
		return affectedType;
	}

	public ShadowingImpact getShadowingImpact() {
		return shadowingImpact;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}
}
